diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryMobSpawner.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryMobSpawner.java
index c9c7209e7..5ddb23ef6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryMobSpawner.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryMobSpawner.java
@@ -39,7 +39,7 @@ public class BlockEntryMobSpawner extends BlockEntry{
     @Override
     public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, World world, int meta) {
         List<String> ids = new ArrayList<>();
-        for (NamespaceID id : EntityDispatcher.idToClassMap.keySet()) {
+        for (NamespaceID id : EntityDispatcher.getInstance().idToEntryMap.keySet()) {
             ids.add(id.toString());
         }
         ListSelectorButtonElement<String> dispatcherIds = new ListSelectorButtonElement<String>(-1, -120, 0, 120, 20, I18n.getInstance().translateKey("model.category.block.spawner.button.id"), ids, "minecraft:pig") {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryDispatcher.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryDispatcher.java
index 8449297ee..5feae79f4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryDispatcher.java
@@ -27,7 +27,7 @@ public class EntityEntryDispatcher extends EntityEntry<Entity> {
 
     @Override
     public Entity getEntityInstance(Minecraft mc, World world) {
-        return EntityDispatcher.createEntityInWorld(id, mc.currentWorld);
+        return EntityDispatcher.getInstance().createEntityInWorld(id, mc.currentWorld);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index f599adb45..7e630527c 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -67,7 +67,6 @@ import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
-import net.minecraft.core.world.saveddata.maps.ItemMapSavedData;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.slf4j.Logger;
@@ -409,7 +408,7 @@ public class PacketHandlerClient extends PacketHandler
             if (tileentity instanceof TileEntityMobSpawner)
             {
                 TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) tileentity;
-                NamespaceID namespaceID = EntityDispatcher.idForClass(setMobSpawnerPacket.entityClass);
+                NamespaceID namespaceID = setMobSpawnerPacket.dispatcherEntry != null ? setMobSpawnerPacket.dispatcherEntry.namespaceID : null;
                 tileEntityMobSpawner.setMobId(namespaceID == null ? "none" : namespaceID.toString());
 
                 tileEntityMobSpawner.setChanged();
@@ -750,7 +749,7 @@ public class PacketHandlerClient extends PacketHandler
         double d2 = (double) addMobPacket.z / 32D;
         float f = (float) (addMobPacket.yaw * 360) / 256F;
         float f1 = (float) (addMobPacket.pitch * 360) / 256F;
-        Mob mob = (Mob) EntityDispatcher.createEntity(addMobPacket.type, mc.currentWorld);
+        Mob mob = (Mob) EntityDispatcher.getInstance().createEntity(addMobPacket.type, mc.currentWorld);
         mob.serverPosX = addMobPacket.x;
         mob.serverPosY = addMobPacket.y;
         mob.serverPosZ = addMobPacket.z;
@@ -1229,7 +1228,7 @@ public class PacketHandlerClient extends PacketHandler
         if (syncIDsPacket.destinationId == PacketSyncIDs.DESTINATION_SOUND_IDS) {
             SoundTypes.setSoundIds(syncIDsPacket.mapping);
         } else if (syncIDsPacket.destinationId == PacketSyncIDs.DESTINATION_ENTITY_IDS) {
-            EntityDispatcher.setNumericIds(syncIDsPacket.mapping);
+            EntityDispatcher.getInstance().setNumericIds(syncIDsPacket.mapping);
         }
     }
     
diff --git a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
index 582835f6d..fd0a4bd93 100644
--- a/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/OpenGLHelper.java
@@ -88,11 +88,11 @@ public class OpenGLHelper {
 		return "Unknown Error";
 	}
 
-	public static void glColor1i(int rgb) {
-		float r = (float)(rgb >> 16 & 0xff) / 255F;
-		float g = (float)(rgb >> 8 & 0xff) / 255F;
-		float b = (float)(rgb & 0xff) / 255F;
-		glColor3f(r, g, b);
+	public static void glColor1i(int argb) {
+		float a = (float)(argb >> 24 & 0xff) / 255F;
+		float r = (float)(argb >> 16 & 0xff) / 255F;
+		float g = (float)(argb >> 8 & 0xff) / 255F;
+		float b = (float)(argb & 0xff) / 255F;
+		glColor4f(r, g, b, a);
 	}
-	
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index b3ac76ce1..e6acd9aa6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -82,6 +82,9 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelStandard<>(Blocks.COBBLE_LIMESTONE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_limestone"));
         addDispatch(new BlockModelStandard<>(Blocks.COBBLE_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_granite"));
         addDispatch(new BlockModelStandard<>(Blocks.COBBLE_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_permafrost"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_BASALT_MOSSY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_basalt_mossy"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_LIMESTONE_MOSSY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_limestone_mossy"));
+        addDispatch(new BlockModelStandard<>(Blocks.COBBLE_GRANITE_MOSSY).setAllTextures(BLOCK_TEXTURES, "minecraft:block/cobbled_granite_mossy"));
 
         addDispatch(new BlockModelStandard<>(Blocks.STONE_POLISHED)
             .setTex(BLOCK_TEXTURES, "minecraft:block/polished_stone_top", S_TB)
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index f9337ba3f..b8d393c62 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -73,7 +73,8 @@ public abstract class EntityRenderer<T extends Entity>
         if (model != null) {
             return model;
         }
-        final NamespaceID id = EntityDispatcher.idForClass(this.appliedClass);
+        EntityDispatcher.EntityDispatcherEntry entry = EntityDispatcher.getInstance().entryForClass(this.appliedClass);
+        final NamespaceID id = entry != null ? entry.namespaceID : null;
         if (id != null) {
             model = EntityGeometryMojangData.Cache.getModelForEntity(id, localId);
         } else {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
index 51560ab2d..c3b23b9bf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
@@ -34,7 +34,7 @@ public class TileEntityRendererMobSpawner extends TileEntityRenderer<TileEntityM
         Entity entity = entityHashMap.get(mobSpawner.getMobId());
         if(entity == null)
         {
-            entity = EntityDispatcher.createEntityInWorld(mobSpawner.getMobId(), WorldClient.EMPTY_WORLD);
+            entity = EntityDispatcher.getInstance().createEntityInWorld(mobSpawner.getMobId(), WorldClient.EMPTY_WORLD);
             entityHashMap.put(mobSpawner.getMobId(), entity);
         }
         if(entity != null)
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index 0b1aa4873..a090dbae0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -25,7 +25,9 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.util.debug.GLFWLoggerCallback;
 import net.minecraft.client.util.debug.OpenGLLoggerCallback;
+import net.minecraft.core.BuildChannel;
 import net.minecraft.core.Global;
+import net.minecraft.core.Version;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.BufferUtils;
@@ -82,8 +84,12 @@ public class GameWindowGLFW implements GameWindow {
     public void init(Minecraft minecraft, int width, int height) {
         mc = minecraft;
 
+        boolean debug = (mc.gameSettings.developerMode.value || Version.BUILD_CHANNEL == BuildChannel.DEVELOPMENT);
+
         LOGGER.info("Initializing GLFW...");
-        GLFWErrorCallback.create(new GLFWLoggerCallback()).set();
+        if (debug) {
+            GLFWErrorCallback.create(new GLFWLoggerCallback()).set();
+        }
         if (!glfwInit()) {
             throw new RuntimeException("GLFW initialization failed!");
         }
@@ -156,7 +162,7 @@ public class GameWindowGLFW implements GameWindow {
         // OpenGL setup
         glfwMakeContextCurrent(window);
         GLCapabilities capabilities = GL.createCapabilities();
-        if (capabilities.OpenGL43) {
+        if (capabilities.OpenGL43 && debug) {
             GL11.glEnable(GL43.GL_DEBUG_OUTPUT);
             GL43.glDebugMessageCallback(new OpenGLLoggerCallback(), NULL);
             LOGGER.info("GL4.3 supported, enabling GL Error logging");
diff --git a/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java b/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
index 30c2bea28..c40b2d017 100644
--- a/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
+++ b/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
@@ -1,12 +1,10 @@
 package net.minecraft.client.util.debug;
 
-import com.mojang.logging.LogUtils;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.ARBFramebufferObject;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL43;
 import org.lwjgl.opengl.GLDebugMessageCallbackI;
-import org.lwjgl.opengl.OpenGLException;
 import org.lwjgl.system.MemoryUtil;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index 07dcacda2..1b491f4a0 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.client.world.chunk.provider.ChunkProviderViewer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.AuroraProvider;
@@ -51,6 +52,12 @@ public class WorldClient extends World {
         biomeProvider = this.worldType.createBiomeProvider(this);
     }
 
+    @Override
+    public void spawnPlayerWithLoadedChunks(Player player, boolean respawning) {
+        super.spawnPlayerWithLoadedChunks(player, respawning);
+        getLevelData().setLastPlayerUUID(player.uuid);
+    }
+
     public Vec3 getDimensionColor(ICamera camera, float partialTick)
     {
         float f1 = getCelestialAngle(partialTick);
diff --git a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java b/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
index ad4411534..b34d11805 100644
--- a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientMP.java
@@ -1,16 +1,19 @@
 package net.minecraft.client.world.save;
 
-import net.minecraft.core.entity.player.Player;
 import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.PlayerIO;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.File;
 import java.util.List;
+import java.util.UUID;
 
 public class SaveHandlerClientMP
 		implements LevelStorage
@@ -57,7 +60,7 @@ public class SaveHandlerClientMP
 	}
 
 	@Override
-	public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
+	public void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<Player> playerList)
 	{
 		
 	}
@@ -98,4 +101,18 @@ public class SaveHandlerClientMP
 		return null;
 	}
 
+	@Override
+	public @Nullable CompoundTag getPlayerData(@Nullable String username, @NotNull UUID uuid) {
+		return null;
+	}
+
+	@Override
+	public void save(@NotNull Player player) {
+
+	}
+
+	@Override
+	public void load(@NotNull Player player) {
+
+	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java b/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java
index 05a1d79ab..ccccb4233 100644
--- a/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java
+++ b/game/client/src/main/java/net/minecraft/client/world/save/SaveHandlerClientSP.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.world.save;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.world.chunk.ChunkLoaderRegionAsync;
 import net.minecraft.core.world.chunk.IChunkLoader;
@@ -7,6 +8,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.save.ISaveFormat;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.save.SaveHandlerBase;
+import org.jetbrains.annotations.NotNull;
 
 import java.io.File;
 import java.util.List;
@@ -15,11 +17,24 @@ public class SaveHandlerClientSP
         extends SaveHandlerBase
 {
 
-    public SaveHandlerClientSP(ISaveFormat saveFormat, File savesDir, String worldDirName, boolean isMultiplayer)
+    public SaveHandlerClientSP(ISaveFormat saveFormat, File savesDir, String worldDirName)
     {
-        super(saveFormat, savesDir, worldDirName, isMultiplayer);
+        super(saveFormat, savesDir, worldDirName);
     }
-    
+
+    @Override
+    public void load(@NotNull Player player) {
+        LevelData data = getLevelData();
+        if (data != null && data.getLastPlayerUUID() != null) {
+            CompoundTag lastPlayerTag = getPlayerData(null, data.getLastPlayerUUID());
+            if (lastPlayerTag != null) {
+                player.load(lastPlayerTag);
+                return;
+            }
+        }
+        super.load(player);
+    }
+
     @Override
     public IChunkLoader getChunkLoader(Dimension dimension)
     {
@@ -30,7 +45,7 @@ public class SaveHandlerClientSP
     }
 
     @Override
-    public void saveLevelDataAndPlayerData(LevelData levelData, List<Player> playerList)
+    public void saveLevelDataAndPlayerData(@NotNull LevelData levelData, @NotNull List<Player> playerList)
     {
         levelData.setSaveVersion(saveFormat.getSaveVersion());
         super.saveLevelDataAndPlayerData(levelData, playerList);
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
index 12e308c1e..37b867c95 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatList.java
@@ -144,9 +144,9 @@ public abstract class StatList
         }
 
         mobEncounterStats = new HashMap<>();
-        for (Map.Entry<NamespaceID, Class<? extends Entity>> entry : EntityDispatcher.idToClassMap.entrySet())
+        for (EntityDispatcher.EntityDispatcherEntry<?> entry : EntityDispatcher.getInstance().entries)
         {
-            mobEncounterStats.put(entry.getKey(), new StatMob(NamespaceID.fromPool("minecraft", "encounter_" + entry.getKey().toString().replace(":", "_")), "stat.encounterMob", entry.getKey()).registerStat());
+            mobEncounterStats.put(entry.namespaceID, new StatMob(NamespaceID.fromPool("minecraft", "encounter_" + entry.namespaceID.toString().replace(":", "_")), "stat.encounterMob", entry.namespaceID).registerStat());
         }
     }
 
@@ -252,7 +252,8 @@ public abstract class StatList
             if (OFFSET_MOB <= id && id < OFFSET_MOB + OFFSET_OFFSET) {
                 @SuppressWarnings("deprecation") // This is converting old stats that used the legacy ids numbers
                 Class<? extends Entity> c = EntityDispatcher.Legacy.getClassFromID(id - OFFSET_MOB);
-                NamespaceID entityID = EntityDispatcher.idForClass(c);
+                EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(c);
+                NamespaceID entityID = entry != null ? entry.namespaceID : null;
                 return mobEncounterStats.get(entityID);
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index 5cb8453d7..f85515d06 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -94,6 +94,9 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
 		stoneToMossMap.put(Blocks.LIMESTONE, Blocks.MOSS_LIMESTONE);
 		stoneToMossMap.put(Blocks.BASALT, Blocks.MOSS_BASALT);
 		stoneToMossMap.put(Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY);
+		stoneToMossMap.put(Blocks.COBBLE_BASALT, Blocks.COBBLE_BASALT_MOSSY);
+		stoneToMossMap.put(Blocks.COBBLE_LIMESTONE, Blocks.COBBLE_LIMESTONE_MOSSY);
+		stoneToMossMap.put(Blocks.COBBLE_GRANITE, Blocks.COBBLE_GRANITE_MOSSY);
 		stoneToMossMap.put(Blocks.BRICK_STONE_POLISHED, Blocks.BRICK_STONE_POLISHED_MOSSY);
 		stoneToMossMap.put(Blocks.LOG_OAK, Blocks.LOG_OAK_MOSSY);
 		
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
index bbff8d921..a88ced793 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWireRedstone.java
@@ -20,6 +20,10 @@ import java.util.Random;
 import java.util.Set;
 
 public class BlockLogicWireRedstone extends BlockLogic {
+    public static final int SIGNAL_MIN = 0;
+    public static final int SIGNAL_MAX = 15;
+    public static final int SIGNAL_STEP = 1;
+
     public static final int MASK_DIRECTION = 0xF0;
     public static final int MASK_POWER = 0x0F;
     private boolean shouldSignal = true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index ce453c96d..09d260d1b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -82,28 +82,15 @@ public final class Blocks {
     public static final Block<?> COBBLE_PERMAFROST = register("cobble.permafrost", "minecraft:block/cobble_permafrost", 15, (b) -> new BlockLogicCobble(b, Material.permafrost, () -> Blocks.GRAVEL))
         .withSound(BlockSounds.PERMAFROST).withHardness(2.0F).withBlastResistance(10F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-
-    public static final Block<?> STONE_POLISHED = register("stone.polished", "minecraft:block/stone_polished", 860, (b) -> new BlockLogic(b, Material.stone))
-        .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<?> GRANITE_POLISHED = register("granite.polished", "minecraft:block/granite_polished", 861, (b) -> new BlockLogic(b, Material.granite))
-        .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<?> LIMESTONE_POLISHED = register("limestone.polished", "minecraft:block/limestone_polished", 862, (b) -> new BlockLogic(b, Material.limestone))
-        .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<?> BASALT_POLISHED = register("basalt.polished", "minecraft:block/basalt_polished", 863, (b) -> new BlockLogic(b, Material.basalt))
-        .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<?> SLATE_POLISHED = register("slate.polished", "minecraft:block/slate_polished", 864, (b) -> new BlockLogic(b, Material.slate))
-        .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<?> PERMAFROST_POLISHED = register("permafrost.polished", "minecraft:block/permafrost_polished", 865, (b) -> new BlockLogic(b, Material.permafrost))
-        .withSound(BlockSounds.PERMAFROST).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<?> NETHERRACK_POLISHED = register("netherrack.polished", "minecraft:block/netherrack_polished", 866, (b) -> new BlockLogic(b, Material.netherrack))
-        .withSound(BlockSounds.STONE).withHardness(0.4F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> COBBLE_BASALT_MOSSY = register("cobble.basalt.mossy", "minecraft:block/cobble_basalt_mossy", 16, (b) -> new BlockLogicCobble(b, Material.stone, () -> Blocks.GRAVEL))
+        .withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.GROWS_FLOWERS);
+    public static final Block<?> COBBLE_LIMESTONE_MOSSY = register("cobble.limestone.mossy", "minecraft:block/cobble_limestone_mossy", 17, (b) -> new BlockLogicCobble(b, Material.stone, () -> Blocks.GRAVEL))
+        .withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.GROWS_FLOWERS);
+    public static final Block<?> COBBLE_GRANITE_MOSSY = register("cobble.granite.mossy", "minecraft:block/cobble_granite_mossy", 18, (b) -> new BlockLogicCobble(b, Material.stone, () -> Blocks.GRAVEL))
+        .withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.GROWS_FLOWERS);
 
     public static final Block<?> PILLAR_MARBLE = register("pillar.marble", "minecraft:block/pillar_marble", 20, (b) -> new BlockLogicAxisAligned(b, Material.marble))
         .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
@@ -1156,6 +1143,28 @@ public final class Blocks {
         .setBlockItem(ItemBlockLamp::new)
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
+    public static final Block<?> STONE_POLISHED = register("stone.polished", "minecraft:block/stone_polished", 860, (b) -> new BlockLogic(b, Material.stone))
+            .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> GRANITE_POLISHED = register("granite.polished", "minecraft:block/granite_polished", 861, (b) -> new BlockLogic(b, Material.granite))
+            .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> LIMESTONE_POLISHED = register("limestone.polished", "minecraft:block/limestone_polished", 862, (b) -> new BlockLogic(b, Material.limestone))
+            .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> BASALT_POLISHED = register("basalt.polished", "minecraft:block/basalt_polished", 863, (b) -> new BlockLogic(b, Material.basalt))
+            .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> SLATE_POLISHED = register("slate.polished", "minecraft:block/slate_polished", 864, (b) -> new BlockLogic(b, Material.slate))
+            .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> PERMAFROST_POLISHED = register("permafrost.polished", "minecraft:block/permafrost_polished", 865, (b) -> new BlockLogic(b, Material.permafrost))
+            .withSound(BlockSounds.PERMAFROST).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<?> NETHERRACK_POLISHED = register("netherrack.polished", "minecraft:block/netherrack_polished", 866, (b) -> new BlockLogic(b, Material.netherrack))
+            .withSound(BlockSounds.STONE).withHardness(0.4F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+
     public static final Block<?> LANTERN_FIREFLY_GREEN = register("lantern.firefly.green", "minecraft:block/lantern_firefly_green", 870,
         (b) -> new BlockLogicLanternFirefly(b, MobFireflyCluster.FireflyColor.GREEN, () -> Items.LANTERN_FIREFLY_GREEN))
         .withSound(BlockSounds.GLASS).withHardness(0.1F).withLightEmission(0.9375F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.LANTERN_FIREFLY_GREEN)
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
index 8531e895a..09fbeb354 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
@@ -41,7 +41,8 @@ public class TileEntityMobSpawner extends TileEntity
     	}
         try {
             if (EntityDispatcher.Legacy.isLegacyKey(mobId)) {
-                this.mobId = EntityDispatcher.idForClass(EntityDispatcher.Legacy.getClassFromEncodeID(mobId)).toString();
+                EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(EntityDispatcher.Legacy.getClassFromEncodeID(mobId));
+                this.mobId = entry != null ? entry.stringID : null;
             }
         } catch (Exception e) {
             LOGGER.error("Failed to convert legacy mobspawner id!", e);
@@ -96,7 +97,7 @@ public class TileEntityMobSpawner extends TileEntity
             byte byte0 = 4;
             for(int i = 0; i < byte0; i++)
             {
-                Mob mob = (Mob) EntityDispatcher.createEntityInWorld(mobId, worldObj);
+                Mob mob = (Mob) EntityDispatcher.getInstance().createEntityInWorld(mobId, worldObj);
 
                 if(mob == null)
                 {
@@ -125,7 +126,7 @@ public class TileEntityMobSpawner extends TileEntity
                     double d5 = (double) z + 0.5D + ((double)worldObj.rand.nextFloat() - 0.5D) * 2D;
                     worldObj.spawnParticle("smoke", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
                     worldObj.spawnParticle("flame", d1, d3, d5, 0.0D, 0.0D, 0.0D, 0);
-                    worldObj.playSoundAtEntity(null, mob, "mob.ghast.fireball", 0.025F, 0.75F);
+                    worldObj.playSoundAtEntity(null, mob, "tile.mobspawner.spawn", 0.025F, 0.75F);
                 }
 
                 mob.spawnExplosionParticle();
@@ -139,7 +140,7 @@ public class TileEntityMobSpawner extends TileEntity
     @Override
 	public Packet getDescriptionPacket()
     {
-        return new PacketSetMobSpawner(x, y, z, EntityDispatcher.classForId(mobId));
+        return new PacketSetMobSpawner(x, y, z, EntityDispatcher.getInstance().entryForId(mobId));
     }
     
     public int countNearbySpawners() {
diff --git a/game/core/src/main/java/net/minecraft/core/current/util/BlockPos.java b/game/core/src/main/java/net/minecraft/core/current/util/BlockPos.java
index c79344c05..00cdfc831 100644
--- a/game/core/src/main/java/net/minecraft/core/current/util/BlockPos.java
+++ b/game/core/src/main/java/net/minecraft/core/current/util/BlockPos.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.current.util;
 
+import net.minecraft.core.util.helper.Direction;
+
 public class BlockPos {
 
 	public final int x;
@@ -32,7 +34,7 @@ public class BlockPos {
 	}
 
 	public BlockPos offset(Direction dir, int dist) {
-		return offset(dist * dir.offsetX, dist * dir.offsetY, dist * dir.offsetZ);
+		return offset(dist * dir.getOffsetX(), dist * dir.getOffsetY(), dist * dir.getOffsetZ());
 	}
 
 	public BlockPos offset(int offsetX, int offsetY, int offsetZ) {
